<!-- 措施迭代申请 -->
<template>
  <div
    class="full-page bg"
    element-loading-text="数据加载中..."
    element-loading-spinner="el-icon-loading"
    element-loading-background="rgba(255,255,255, 0.5)"
    v-loading.fullscreen.lock="markLoading"
  >
    <div class="search-container">
      <el-form
        ref="form"
        :model="searchForm"
        label-width="auto"
        style="width: 100%"
      >
        <el-row :gutter="20">
          <el-col :span="5">
            <el-form-item label="项目名称">
              <el-input
                v-model="searchForm['PROJECT_NAME_']"
                clearable
                placeholder="请输入项目名称"
              >
              </el-input>
            </el-form-item>
          </el-col>
          <el-col :span="5">
            <el-form-item label="牵头市领导">
              <el-input
                clearable
                placeholder="请输入牵头市领导"
                v-model="searchForm['leader_']"
              >
              </el-input>
            </el-form-item>
          </el-col>
          <!-- <el-col :span="4">
						<el-form-item label="项目类型">
							<dict-select dictCode="xmlx" :hasDefaultOption="true" clearable
								:disabled="disabled" v-model="row.distributionType"
								style="width: 100%" placeholder="请选择分发类型" />
						</el-form-item>
					</el-col> -->

          <el-col :span="2">
            <el-button
              icon="el-icon-search"
              type="primary"
              class="btn btn-plus"
              @click="handleSearch"
            >
              搜索
            </el-button>
          </el-col>
        </el-row>
      </el-form>
    </div>
    <el-row :gutter="10" class="main-table-container flex">
      <el-col
        :span="24"
        class="table-container"
        ref="contentPanel"
        style="padding: 20px"
      >
        <div style="margin-bottom: 10px" ref="btnPanel">
          <!-- <el-button icon="el-icon-plus" type="primary" class="btn btn-plus" @click="handleAdd">
						{{ this.$t('common.add') }}
					</el-button>
					<el-button slot="reference" icon="el-icon-delete" type="danger" class="btn btn-delete"
						:disabled="!multipleSelection.length>0" @click="handleDelete">
						{{ this.$t('common.delete') }}
					</el-button> -->
        </div>
        <div :style="{width: '100%', height: `${tableMaxHeight}` + 'px'}">
          <el-table
            stripe
            size="mini"
            v-loading="loading"
            ref="multipleSelection"
            :data="tableData"
            :max-height="tableMaxHeight"
            :style="{width: '100%'}"
            @selection-change="handleSelectionChange"
          >
            <el-table-column
              type="index"
              label="序号"
              width="55"
              align="center"
            ></el-table-column>
            <el-table-column
              prop="projectName"
              show-overflow-tooltip
              label="项目名称"
              align="center"
            >
            </el-table-column>
            <el-table-column
              prop="leader"
              show-overflow-tooltip
              label="牵头市领导"
              align="center"
            >
            </el-table-column>
            <!-- <el-table-column prop="projectType" show-overflow-tooltip label="项目类型" align="center">
							<template v-slot="{row}">
							  {{ getDictName('xmlx', row.projectType) }}
							</template>
						</el-table-column> -->
            <el-table-column
              prop="closing"
              show-overflow-tooltip
              label="是否结项"
              align="center"
            >
              <template v-slot="{row}">
                {{ row.closing === '0' ? '已结项' : '未结项' }}
                <!-- {{ getDictName('ggbb_lyqd', row.closing) }} -->
              </template>
            </el-table-column>
            <el-table-column
              show-overflow-tooltip
              align="center"
              fixed="right"
              label="操作"
            >
              <template slot-scope="scope">
                <el-link
                  type="primary"
                  :underline="false"
                  class="cloumn-btn"
                  icon="el-icon-refresh"
                  @click="handleDbClick(scope.row)"
                >
                  迭代
                </el-link>
                <el-link
                  icon="el-icon-refresh-left"
                  type="danger"
                  :underline="false"
                  class="cloumn-btn withdraw"
                  @click="handleAppear(scope.row)"
                >
                  撤回
                </el-link>
              </template>
            </el-table-column>
          </el-table>
        </div>
        <pagination
          ref="paginationPanel"
          style="margin-top: 10px"
          :pageResult="queryParam.pageBean"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
        />
      </el-col>
    </el-row>
    <MeasureDialog ref="MeasureDialog" @getData="getData"></MeasureDialog>
  </div>
</template>

<script>
import pagination from '@/components/pagination'
import {TableMixin} from '@/mixins/tableMixin'
import dictUtils from '@/components/dict/DictSelectUtils.js'
import utils from '@/utils.js'
import majorProjects from '@/api/MajorReformProjects/majorProjects.js'
import MeasureDialog from './components/MeasureDialog.vue'
import measureIterationApplication from '@/api/projectActionIteration/measureIterationApplication.js'
export default {
  name: 'MajorProjects',
  components: {
    pagination,
    MeasureDialog
  },
  mixins: [TableMixin],
  data() {
    return {
      markLoading: false,
      searchForm: {},
      loading: false,
      tableData: [],
      multipleSelection: [],
      treeData: [],
      querys: [
        {
          group: 'main',
          operation: 'EQUAL',
          parentGroup: '',
          property: 'SEND_STATUS_',
          relation: 'AND',
          value: 1
        },
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'project_name_',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'leader_',
          relation: 'AND',
          value: ''
        }
      ],
      typeValue: [],
      queryParam: {
        pageBean: {
          page: 1,
          pageSize: 20,
          total: 0
        }
      },
      unitValue: [],
      pilotSpecificMeasuresList: []
    }
  },

  created() {
    this.jbList = dictUtils.getDictItemsFromCache('subjec_type')
    this.getData(this.queryParam)
  },
  mounted() {},
  methods: {
    // 撤回
    handleAppear(row) {
      this.$confirm(`确认撤回吗？`, this.$t('common.tips'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'error'
      }).then(() => {
        this.getPilotSpecificMeasuresList(row.id, [1]).then(() => {
          let data = {
            ids: [],
            status: 0,
            approvalResults: 2
          }
          if (this.pilotSpecificMeasuresList.length) {
            this.pilotSpecificMeasuresList.forEach(e => {
              data.ids.push(e.id)
            })
            measureIterationApplication.auditSave(data, res => {
              if (res.state) {
                row.status = 1
                this.$message.success('撤回成功')
                this.handleSearch()
              } else {
                this.$message.error('撤回失败')
              }
              this.markLoading = false
            })
          } else {
            this.$message.error('暂无可撤回操作')
            this.markLoading = false
          }
        })
      })
    },
    // 获取举措数据
    getPilotSpecificMeasuresList(id) {
      return new Promise(reslove => {
        this.markLoading = true
        let data = {
          pageBean: {
            page: 1,
            pageSize: 20,
            total: 0
          },
          querys: [
            {
              group: 'main',
              operation: 'EQUAL',
              parentGroup: '',
              property: 'h.project_id_',
              relation: 'AND',
              value: id
            },
            {
              group: 'statusGroup',
              operation: 'IN',
              parentGroup: '',
              property: 'h.status_',
              relation: 'AND',
              value: [1]
            }
          ]
        }
        measureIterationApplication.gteAuditMeasuresDetail(data, res => {
          if (res && res.rows && res.rows.length) {
            this.pilotSpecificMeasuresList = res.rows
          }
          reslove()
        })
      })
    },
    getDictName(code, value) {
      console.log(code, value)
      return utils.getDictName(code, value)
    },
    changeUnit(value) {
      let nodesObj = this.$refs['cascader'].getCheckedNodes()
      if (nodesObj != []) {
        this.querys[2].value = nodesObj[0].data.id
      } else {
        this.querys[2].value = ''
      }
    },
    handleSearch() {
      this.tableLoading = true
      let data = JSON.parse(JSON.stringify(this.queryParam))
      let obj = JSON.parse(JSON.stringify(this.searchForm))
      let querys = [
        {
          group: 'main',
          operation: 'EQUAL',
          parentGroup: '',
          property: 'SEND_STATUS_',
          relation: 'AND',
          value: 1
        }
      ]
      for (let i in obj) {
        if (obj[i]) {
          querys.push({
            group: 'main',
            operation: 'LIKE',
            parentGroup: '',
            property: i,
            relation: 'AND',
            value: obj[i]
          })
        }
      }
      data.querys = querys
      this.getData(data,1)
    },
    //获取数据
    getData(data,page) {
      if (page) {
        this.queryParam.pageBean.page = page
      }
      this.loading = true
      this.tableData = []
      this.queryParam.querys = []
      if (this.querys[0].value) {
        this.queryParam.querys.push(this.querys[0])
      }
      if (this.querys[1].value) {
        this.queryParam.querys.push(this.querys[1])
      }
      measureIterationApplication.getMeasuresAuditList(data, false, true, res => {
        if (res.rows) {
          this.tableData = res.rows
          // this.tableData.forEach((e) => {
          // 	this.jbList.forEach((j) => {
          // 		let typeName = ''
          // 		e.type.split(',').forEach((t) => {
          // 			if (t == j.value) {
          // 				typeName += j.name + ','
          // 				console.log(j.name)
          // 			}
          // 		})
          // 		if (typeName.length > 0) {
          // 			e.typeName = typeName.substr(
          // 				0,
          // 				typeName.length - 1
          // 			)
          // 		}
          // 	})
          // })
          this.queryParam.pageBean.total = res.total
          this.$set(this.tableData)
          this.loading = false
        }
      })
    },
    // expandHandle() {
    // 	this.expandAll = !this.expandAll
    // 	this.expandNodes(this.$refs.tree.store.root)
    // },
    // // 遍历树形数据，设置每一项的expanded属性，实现展开收起
    // expandNodes(node) {
    // 	node.expanded = this.expandAll
    // 	for (let i = 0; i < node.childNodes.length; i++) {
    // 		node.childNodes[i].expanded = this.expandAll
    // 		if (node.childNodes[i].childNodes.length > 0) {
    // 			this.expandNodes(node.childNodes[i])
    // 		}
    // 	}
    // },
    // filterNode(value, data) {
    // 	if (!value) return true
    // 	return data.name.indexOf(value) !== -1
    // },
    // //树选中
    // handleNodeClick(data) {
    // 	this.parentId = data.id
    // 	this.querys[2].value = data.id
    // 	this.getData(1)
    // },
    //添加
    handleAdd() {
      this.$refs.MeasureDialog.add()
    },
    //删除
    handleDelete() {
      this.$confirm(this.$t('common.sureDelete'), this.$t('common.tips'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning'
      })
        .then(() => {
          majorProjects.delDate(this.multipleSelection, res => {
            if (res.state) {
              this.$notify({
                type: 'success',
                message: '删除成功',
                duration: 2000
              })
            }
            this.getData()
          })
        })
        .catch(() => {})
    },
    //修改
    handleDbClick(data) {
      this.$refs.MeasureDialog.add(data)
    },

    //表格选中
    handleSelectionChange(val) {
      this.multipleSelection = []
      this.$refs.multipleSelection.selection.forEach(item => {
        this.multipleSelection.push(item.id)
      })
    },
    //展示数量
    handleSizeChange(val) {
      this.queryParam.pageBean.pageSize = val
      this.getData()
    },
    //表格页数
    handleCurrentChange(val) {
      this.queryParam.pageBean.page = val
      this.getData()
    }
  }
}
</script>

<style lang="scss" scoped>
.common-tree-container {
  height: calc(100% - 70px);
  margin-top: 0.52083vw;
  padding: 1.04167vw 1.04167vw;
  background-color: #fff;
  position: relative;
  box-sizing: border-box;
  overflow-y: auto;
  border-radius: 20px;
  box-shadow: 0px 0px 0.625vw 0 rgba(92, 102, 83, 0.2);
}

.container-head {
  display: flex;
  align-items: center;

  i {
    font-size: 16px;
    margin-left: 5px;
    font-weight: 600;
    cursor: pointer;
  }
}
.cloumn-btn {
  border: 1px solid #2761ff;
  padding: 3px 10px;
  border-radius: 5px;
  &:nth-child(1) {
    margin-right: 5px;
  }
  &:nth-child(1):hover {
    background-color: #2761ff;
    color: #fff;
  }
  &:nth-child(2):hover {
    background-color: #2761ff;
    color: #fff;
  }
  // &:nth-child(2):hover {
  //   background-color: #f56c6c;
  //   color: #fff;
  //   border-color: #f56c6c;
  // }
  /deep/ i,
  span {
    font-size: 16px;
  }
}
</style>
